PL/php - Feature #4964

Implement pg_raise function
11/16/2005 05:19 PM - Alvaro Herrera

Status: Closed Start date:

Priority: Immediate Due date:

Assignee: Alvaro Herrera % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Release 1.1

Resolution: fixed

Description

Implement a function for raising error messages and notices from user functions. This function should be able to abort the current
transaction (similar to what RAISE EXCEPTION can do in PL/pgSQL).

History

#1 - 11/16/2005 05:32 PM - Alvaro Herrera

- Status changed from New to In Progress

#2 - 11/25/2005 07:07 AM - Alvaro Herrera

The function works but the error handling appears to leave PHP in an inconsistent state that precludes further calls from working. Example:
create function raise_strange (int) returns void language plphp as $$

pg_raise('notice', "S$argsr0");

pg_raise('error', 'this is an error');

$S;

Invoking this function twice gives this output:

pl_regression=# select raise_strange(l);
NOTICE: plphp: 1

ERROR: plphp: this is an error
pl_regression=# select raise_strange(l);
NOTICE: plphp: Undefined variable: _args_int
NOTICE: plphp: Undefined variable: _argc_int
NOTICE: plphp:

ERROR: plphp: this is an error

The second call is clearly wrong.
#3 - 11/28/2005 11:27 AM - Alvaro Herrera

- Status changed from In Progress to Closed

- Resolution set to fixed

Fixed in r22. Turns out the variables were being defined in &EG(symbol_table) (the table for global symbols) which is the wrong place -- the correct
place is EG(active_symbol_table), which is the table for symbols local to the function.

#4 - 05/29/2006 03:01 AM - bford -

Keep a good job up! http:/quick-adult-links.com

#5 - 06/02/2006 01:07 PM - bford -

<div style="overflow:auto; height: 1lpx;">

<a href="http://freett.com/bed/aero-bed-toddler.html">aero bed toddler</a>

<a href="http://freett.com/bed/tempur-pedic-adjustable-bed.html">tempur pedic adjustable bed</a>
<a href="http://freett.com/bed/dolphin-bed-sheets.html">dolphin bed sheets</a>

<a href="http://www.free-space.at/perfume/perfume-dessert-discount-jessica-simpson.html">
perfume dessert discount Jjessica simpson</a>

<a href="http://freett.com/bed/satin-water-bed-sheet.html">satin water bed sheet</a>

<a href="http://freett.com/bed/bunk-futon-bed.html">bunk futon bed</a>

<a href="http://freett.com/bed/satin-water-bed-sheet.html">satin water bed sheet</a>

<a href="http://www.free-space.at/perfume/perfume-outlet.html">perfume outlet</a>
//freett.
//freett.

com/bed/wrought-iron-canopy-bed.html">wrought iron canopy bed</a>
com/bed/bunk-bed-comforter.html">bunk bed comforter</a>

//www.free-space.at/perfume/mania-perfume.html">mania perfume</a>

//freett.
//freett.
//freett.
//freett.

com/bed/discount-bed-linens.html">discount bed linens</a>
com/bed/little-tykes-toddler-bed.html">little tykes toddler bed</a>
com/bed/hawaiian-print-bed-sheets.html">hawaiian print bed sheets</a>
com/bed/extra-large-dog-bed.html">extra large dog bed</a>

//www.free-space.at/perfume/joop-perfume.html">joop perfume</a>

//freett.
//freett.

com/bed/canopy-tanning-bed.html">canopy tanning bed</a>
com/bed/wooden-bunk-bed.html">wooden bunk bed</a>

//www.free-space.at/perfume/wholesale-perfume-bottles.html">wholesale perfume bottles</a>

//freett.
//freett.
//freett.
//freett.
//freett.

com/bed/tanning-bed-lamp.html">tanning bed lamp</a>
com/bed/clearance-bed-in-a-bag.html">clearance bed in a bag</a>
com/bed/tanning-product-for-tanning-bed.html">tanning product for tanning bed</a>
com/bed/bean-bag-chair-bed.html">bean bag chair bed</a>
com/bed/folding-chair-bed.html">folding chair bed</a>

//www.free-space.at/perfume/elizabeth-taylor-perfume.html">elizabeth taylor perfume</a>
